/*
 * S.F.Sanchez, Oct 2002
 * This rutine gets a solution to a generalized 
 * least square fitting. It has been 
 * taken from NR. Use with care!
 *
 */


#define SWAP(a,b) {temp=(a);(a)=(b);(b)=temp;}


void gl_fit( float x[], float y[], float sig[], int nini, int ndat, float a[], float s_a[], float d_a[], int ia[], int ma, float *chisq, float chisq_con, void (*funcs)(float, float[], float*));



float gl_chisq_det( float y0[], float y1[], float sig[], int nini, int ndat);

void gl_lfit( float x[], float y[], float sig[], int ndat, float a[], int ia[], 
	   int ma, float **covar, float *chisq, void (*funcs)(float, float[], int));
void gl_covsrt(float **covar, int ma, int ia[], int mfit);
void gl_gaussj(float **a, int n, float **b, int m);


/*
 * Functions to fit using the above defined minimization tools
 *
 */

void gl_fit_gauss(float x, float a[], float *y);
void polyfit(float *xi, float *yi, int ni, float *a, int mai);
void gl_fit_poly(float x, float afunc[], int ma);
void legendrefit(float *xi, float *yi, int ni, float *ai, int mai);
void gl_fit_legendre(float x, float afunc[], int ma);
float legendre(float x,int n);
int factorial(int n);
float combi(int n,int k);

float chebyshev(float x,int n);
void gl_fit_chebyshev(float x, float afunc[], int ma);
void chebyshevfit(float *xi, float *yi, int ni, float *ai, int mai);


void gl_lfit_par( float x[], float y[], float sig[], int ndat, float a[], 
		  int ia[], int ma, float **covar, float *chisq, float P1[], float P2[], void (*funcs)(float, float[], float[], float[], int));
void gl_lfit_gauss(float x, float afunc[], float c[], float s[], int ma);
void multi_gaussfit(float *xi, float *yi, int ni, float *ai, int mai, float *ci, float *si);


