/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2008, CAHA
! IDENT        Mosaic_cubes.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      Mosaic Cubes
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  2002-Dec-17 : Creation, SF.
------------------------------------------------------------------------------*/
#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"

#include <IFU_io.h>

#include "stats.h"

#define MAX_MOSAICS 30


main(int argc, char **argv)
{

  FILE *config_id;  
  char config[80];
  char fitsfiles[MAX_MOSAICS][80];
  float dx[MAX_MOSAICS],dy[MAX_MOSAICS];
  float dxmin,dxmax,dymin,dymax;
  int i,j,k,n,n_fits;
  float tmp_f;
  char input_filename[80];
  char delta_filename[80];
  char output_filename[80];
  double crval[3];
  double cdelt[3];
  IMAGE3D in_cube,out_cube;
  float *out_array;
  long npix;
  int nx_start,ny_start;
  int ii,jj,kk,j_file;
  char **argval, **arglabel;
  long npix_out[3];

  float x0,y0;
  int npoly_x,npoly_y;
  int n_start,n_end;
  float aperture;
  float scale;
  float delta_x,delta_y;
  float *x_c,*y_c;
  float *x,*y,*point;
  float *x_out,*y_out;
  int kmed;
  float x1,y1,x_val,y_val,sum;
  int i_min,i_max,j_min,j_max;
  int nx,ny,nz;
  int NX,NY,NZ;
  float val;
  float min,max;
  float *id;
  float *coeff;
  int nx_0,ny_0;
  int I1,I2,J1,J2;
  float Y1,Y2,Y3,Y4;
  float DX,DY;
  float t,u;
  float VAL;
  float xx,yy;
  float x_med,x_sig,y_med,y_sig;
  int nsigma;
  int smooth;
  FILE *FH;

  int flag;
  char car;
  int np;
  int temp_i;
  float temp;

  if (argc<4) {
      printf("USE: DAR_det_cube input_cube.fits delta_file.txt output_cube \n");
      return(0);
  }
/*
 * Reading the input parameters
 */
   set_user_dataformat();
  strcpy(input_filename,argv[1]);
  strcpy(delta_filename,argv[2]);
  strcpy(output_filename,argv[3]);



  np=0;
  if ((FH=fopen(delta_filename,"r"))==NULL) {
      printf("Error opening file: %s\n",delta_filename);
      return(-1);
  } else {    
      while((car=getc(FH))!=EOF) {
	  flag=1;
	  if (car=='\n')
	  {
	      np+=1;
	      flag+=1;
	  }
      }
      if (flag==1) {
	  np=np+1;
      } else {
	  np=np;
      }
//      np=np-1;

      x_c = (float *)malloc((np)*sizeof(float));  	
      y_c = (float *)malloc((np)*sizeof(float));  	

      rewind(FH);
	flag=0;
	while(flag==0) {
	    car=getc(FH);
	    if (car=='\n') {
		 flag=1;
	    }
	}

      for (j=0;j<np;j++) {
	  fscanf(FH, "%d", &temp_i);
	  fscanf(FH, "%f", &temp);
	  x_c[j]=temp;
	  fscanf(FH, "%f", &temp);
	  y_c[j]=temp;
      }
  }


  open_cube(&in_cube,input_filename,"I");
  if (argc<9) {
      n_start=0;
      n_end=in_cube.nz;
  }
  nx=in_cube.nx;
  ny=in_cube.ny;
  nz=in_cube.nz;



  if(!RD_desc(&in_cube,"CRVAL1",DOUBLE,1,&crval[0])) {
      crval[0]=1;
  } 
  if(!RD_desc(&in_cube,"CRVAL2",DOUBLE,1,&crval[1])) {
      crval[1]=1;
  } 
  if(!RD_desc(&in_cube,"CRVAL3",DOUBLE,1,&crval[2])) {
      crval[2]=1;
  } 
  if(!RD_desc(&in_cube,"CDELT1",DOUBLE,1,&cdelt[0])) {
      cdelt[0]=1;
  }

  if(!RD_desc(&in_cube,"CDELT2",DOUBLE,1,&cdelt[1])) {
      cdelt[1]=1;
  } 
  if(!RD_desc(&in_cube,"CDELT3",DOUBLE,1,&cdelt[2])) {
      cdelt[2]=1;
  } 


  scale=1;
  cdelt[0]=cdelt[0]/scale;
  cdelt[1]=cdelt[1]/scale;

  npix_out[0]=floor(in_cube.nx*scale);
  npix_out[1]=floor(in_cube.ny*scale);
  npix_out[2]=in_cube.nz;
  nx_0=npix_out[0];
  ny_0=npix_out[1];
//  nz=in_cube.nz;
  


  x_out = (float *)malloc((in_cube.nz)*sizeof(float));  	
  y_out = (float *)malloc((in_cube.nz)*sizeof(float));  	
  id = (float *)malloc((in_cube.nz)*sizeof(float));  	


  if (np!=nz) {
      printf("The number of entries in the file %d does not match with\n the Z-dimension of the cube %d",np,nz);
      return(0);
  }


  printf("DAR file '%s' readed\n",delta_filename);

  
  create_cube(&out_cube,output_filename,npix_out,crval,cdelt,FLOAT,"DAR_COR Cube",NULL);
  for (k=0;k<nz;k++) {
      for (i=0;i<nx_0;i++) {
	  for (j=0;j<ny_0;j++) {
	      DX=x_c[k];
	      DY=y_c[k];
	      xx=i/scale+DX;//-delta_x;
	      yy=j/scale+DY;//-delta_y;
	      I1=floor(xx);
	      I2=floor(xx+1);
	      J1=floor(yy);
	      J2=floor(yy+1);
	      if (I1<0) {
		  I1=0;
	      }
	      if (I2<0) {
		  I2=0;
	      }
	      if (I2>nx-1) {
		  I2=nx-1;
	      }
	      if (I1>nx-1) {
		  I1=nx-1;
	      }
	      if (J1<0) {
		  J1=0;
	      }
	      if (J2<0) {
		  J2=0;
	      }
	      if (J1>ny-1) {
		  J1=ny-1;
	      }
	      if (J2>ny-1) {
		  J2=ny-1;
	      }
	      Y1=RD_cube(&in_cube,I1,J1,k);
	      Y2=RD_cube(&in_cube,I2,J1,k);
	      Y3=RD_cube(&in_cube,I2,J2,k);
	      Y4=RD_cube(&in_cube,I1,J2,k);
	      t=xx-I1;
	      u=yy-J1;
	      VAL=((1-t)*(1-u))*Y1+(t*(1-u))*Y2+(t*u)*Y3+((1-t)*u)*Y4;
	      VAL=VAL/(scale*scale);
	      WR_cube(&out_cube,i,j,k,VAL);
	  }
      }
  }   

      close_cube(&out_cube); 
      close_cube(&in_cube); 
      
      exit_session(0);
      return(0);	
}



