/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of mdist_cor_sp.pl
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"
#include "gl_lsq.h"

main(int argc, char *ARGV[])
{
    
    FILE *FH;
    char infile[80],out_file[80],disp_file[80];
    char file[80];
    IMAGE2D image,dist,dist_cor;

    int aperture;
    int nsigma,npoly,nx_min,nx_max,plot;
    int nsigma2,ny_cen,do_med,nbox,nm;
    float fmin,fmax,dnx_min,dnx_max;
    float *spec,*w,*w_new,*out_spec,*out_array;
    long npix[2];
    double start[2];
    double step[2];
    float mean_flux,sigma_flux,temp;
    float xp[1000],yp[1000],wp[1000],mp[1000],sxp[1000];
    float xtt[1000],ytt[1000],delta_xp[1000];
    int i,j,k,kk,np;
    int i_min,i_max,i_peak;
    int a,b,c;
    float fa,fb,fc,den,x_peak;
    char QUIT,command,car;
    float borders[4],borders_ini[4];
    float xs[1],ys[1],xx[2],yy[2];
    int flag;
    float maximun;
    float x,y,x_cen,x_delta,y_cen,y_delta;
    int n_peak,peak_found;
    float *peaks_cen,*peaks_now,*dpeaks_now,*a_peaks,*a_new_peaks;
    float *x_of_peaks;
    float *tmp;
    int j_min,j_max;
    float me,sig;
    float *xP,*yP,*sxP;
    float *xt;
    float *coeff;
    float *a_dist,*a_i_new,*da_i_new,*a_i_old;
    float dpeak,dpeak_last;

    if (argc<9) {
	printf("USE: mdist_cor_sp EXTRACTED.fits APERTURE NSIGMA NPOLY OUTPUT.fits DISTORSION.fits NX_min NX_max plot [NSIGMA2] [BOX] [NY_CEN] [file.id]\n");
	return(0);
    }
    set_user_dataformat();
    strcpy(infile,ARGV[1]);    
    aperture=atoi(ARGV[2]);
    nsigma=atoi(ARGV[3]);
    npoly=atoi(ARGV[4]);
    strcpy(out_file,ARGV[5]);
    strcpy(disp_file,ARGV[6]);
    nx_min=atoi(ARGV[7]);
    nx_max=atoi(ARGV[8]);
    plot=atoi(ARGV[9]);
    nsigma2=4;
    ny_cen=0;
    do_med=0;
    nsigma2=3;
    if (argc==11) {
	nsigma2=atoi(ARGV[10]);
    }
    nbox=0;
    if (argc==12) {
	nsigma2=atoi(ARGV[10]);
	nbox=atoi(ARGV[11]);
    }
    if (argc==13) {
	nsigma2=atoi(ARGV[10]);
	nbox=atoi(ARGV[11]);
	ny_cen=atoi(ARGV[12]);
    }
    command=' ';
    if (argc==14) {
	nsigma2=atoi(ARGV[10]);
	nbox=atoi(ARGV[11]);
	ny_cen=atoi(ARGV[12]);
	strcpy(file,ARGV[13]);
	command='F';
    }

    open_frame(&image,infile,"I");
    npix[0]=image.nx;
    npix[1]=image.ny;
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;




    fmin=1e12;
    fmax=-1e12;
    spec = (float *)malloc((image.nx)*sizeof(float));  	
    w = (float *)malloc((image.nx)*sizeof(float));  	
    out_spec = (float *)malloc((image.nx)*sizeof(float)); 
    w_new = (float *)malloc((image.nx)*sizeof(float));  	 	
    for (nm=0;nm<image.nx;nm++) {    	
	spec[nm]=RD_frame(&image,nm,ny_cen);
	w[nm]=1.0*nm;
	if (fmax<spec[nm]) {
	    fmax=spec[nm];
	}
	if (fmin>spec[nm]) {
	    fmin=spec[nm];
	}
    
    }

    printf(".\n");
    fflush(stdout);

    mean_flux=fmean(spec,image.nx);
    sigma_flux=fsigma(spec,image.nx,mean_flux);

    for (i=0;i<1000;i++) {
	delta_xp[i]=0;
    }
    printf("Looking for peaks\n");
    np=0;
    for (i=nx_min;i<nx_max;i++) {
	if ((spec[i]-mean_flux)>(nsigma*sigma_flux)) {
	    xs[0]=1.0*i;
	    ys[0]=spec[i];
	    i_min=(int)floor(xs[0])-aperture;
	    i_max=(int)floor(xs[0])+aperture;
	    i_peak=(int)floor(xs[0]);
	    for (i=i_min;i<i_max;i++) {
		if ((spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
		    i_peak=i;
		}
	    }
	    a=i_peak-1;
	    b=i_peak;
	    c=i_peak+1;
	    fa=-spec[a];
	    fb=-spec[b];
	    fc=-spec[c];
	    den=(fc-2*fb+fa);
	    if (den!=0) {
		x_peak=c-(b-a)*((fc-fb)/den+0.5);
	    } else {
		x_peak=i_peak;
	    }
	    xp[np]=x_peak;
	    yp[np]=spec[i_peak];
	    delta_xp[np]=0;
	    mp[np]=1;
	    np++;
	}




    }
    printf("DONE\n");
    printf("%d peaks found\n",np);

    borders_ini[0]=0.0;
    borders_ini[1]=1.0*image.nx;
    borders_ini[2]=fmin;
    borders_ini[3]=fmax;
    borders[0]=0.0;
    borders[1]=1.0*image.nx;
    borders[2]=fmin;
    borders[3]=fmax;
// 
//  Main Loop to select the features.
// 
    QUIT='N';
    printf("a => Unzoom\n");
    printf("x => X-Zoom\n");
    printf("y => Y-Zoom\n");
    printf("m => Mark a peak\n");
    printf("d => delete a peak\n");
    printf("r => Move right\n");
    printf("l => Move left\n");
    printf("R => Load a file\n");
    printf("W => Save a file\n");
    printf("F => Load a file and recenter the peaks\n");
    printf("Q => Quit\n");
    cpgopen("/xs");
    cpgask(0);
    do {
//    while(QUIT!='Y') {
	cpgsfs(1.2);
	cpgscf(2);             //  Set character font
	cpgslw(2);             //  Set line width
	cpgsch(1.2);           //  Set character height
	cpgenv(borders[0],borders[1],borders[2],borders[3],0,1);
	cpgsci(1);
	cpgsci(7);
	cpgline(image.nx,w,spec);
	cpgsch(2);
	cpgsci(5);
	for (i=0;i<np;i++) {
	    if (mp[i]==1) {
		xs[0]=xp[i];
		ys[0]=yp[i];
		cpgpt(1,xs,ys,2);
	    }
	}
	cpgsch(1.2);
	cpgsci(1);

	if (command=='F') {
	    QUIT='Y';
//	    printf("Identification file to recenter?");
//	    scanf("%s",file);
	    printf("Opening file: %s\n",file);
	    np=0;
	    if ((FH=fopen(file,"r"))==NULL) {
		printf("Error opening file: %s\n",file);
		return(-1);
	    } else {    
		while((car=getc(FH))!=EOF) {
		    flag=1;
		    if (car=='\n')
		    {
			np+=1;
			flag+=1;
		    }
		}
		if (flag==1) {
		    np=np+1;
		} else {
		    np=np;
		}
		printf("NP=%d\n",np);
		rewind(FH);
		for (j=0;j<np;j++) {
		    fscanf(FH, "%f", &xtt[j]);
		}
		
		for (j=0;j<np;j++) {
		    x=xtt[j];
		    i_min=(int)(x)-aperture;
		    i_max=(int)(x)+aperture;
		    i_peak=(int)(x);
		    maximun=-1e12;
		    for (i=i_min;i<i_max;i++) {
			if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
			    i_peak=i;
			    maximun=spec[i];
			}
		    }
		    a=i_peak-1;
		    b=i_peak;
		    c=i_peak+1;
		    fa=-spec[a];
		    fb=-spec[b];
		    fc=-spec[c];
		    den=(fc-2*fb+fa);
		    if (den!=0) {
			x_peak=c-(b-a)*((fc-fb)/den+0.5);
		    } else {
			x_peak=i_peak;
		    }
		    xp[j]=x_peak;
		    yp[j]=spec[i_peak];
		    delta_xp[j]=x-x_peak;
		    mp[j]=1;
//			printf("VAL=%d %d %f %f %f\n",j,np,xtt[j],xp[j],yp[j]);
		    
		}
		
		
		for (i=0;i<np;i++) {
		    for (j=(i+1);j<np;j++) {
			if (xp[j]<xp[i]) {
			    temp=xp[j];
			    xp[j]=xp[i];
			    xp[i]=temp;
			}    
		    }
		}
		for (j=0;j<np;j++) {
//			printf("%d %f\n",j,xp[j]);
		    mp[j]=1;
		    yp[j]=spec[(int)xp[j]];			
		}
	    }
	    fclose(FH);
//		printf("%d lines found\n",np);
	    command='F';
	    
	    cpgsch(2);
	    cpgsci(5);
	    for (i=0;i<np;i++) {
		xs[0]=xp[i];
		ys[0]=yp[i];
		if (mp[i]==1) {
		    cpgpt(1,xs,ys,2);
		}
	    }
	    cpgsci(1);
	    cpgsch(1.2);
	    
	}
    
//
	if (command!='F') {
	    command=' ';
	} else {
	    if (plot==0) {
		command='X';
	    }
	}
	while (command!='X') {
//
	    cpgband(7,0,50,50,&x,&y,&command);
	    //printf('%d\n',command);
	    if (command=='x') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x;
		x_delta=0.75*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='y') {
		y_cen=0.5*(borders[3]-borders[2])+borders[2];
		y_delta=0.5*(borders[3]-borders[2]);
		y_cen=y;
		y_delta=0.75*y_delta;
		borders[2]=y_cen-y_delta;
		borders[3]=y_cen+y_delta;
		command='X';
	    }
	    if (command=='r') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x_cen+0.25*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='l') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x_cen-0.25*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='a') {
		for (i=0;i<4;i++) {
		    borders[i]=borders_ini[i];
		}
		command='X';
	    }
	    if (command=='q') {
		command='X';
		QUIT='Y';
	    }
	    

	    if (command=='R') {
		printf("Identification file?");
		scanf("%s",file);
		printf("Opening file: %s\n",file);
		np=0;
		if ((FH=fopen(file,"r"))==NULL) {
		    printf("Error opening file: %s\n",file);
		    return(-1);
		} else {    
		    while((car=getc(FH))!=EOF) {
			flag=1;
			if (car=='\n')
			{
			    np+=1;
			    flag+=1;
			}
		    }
		    if (flag==1) {
			np=np+1;
		    } else {
			np=np;
		    }
		    printf("NP=%d\n",np);
		    rewind(FH);
		    for (j=0;j<np;j++) {
			fscanf(FH, "%f", &xp[j]);
		    }

		    for (i=0;i<np;i++) {
			for (j=(i+1);j<np;j++) {
			    if (xp[j]<xp[i]) {
				temp=xp[j];
				xp[j]=xp[i];
				xp[i]=temp;
			    }    
			}
		    }
		    for (j=0;j<np;j++) {
//			printf("%d %f\n",j,xp[j]);
			mp[j]=1;
			yp[j]=spec[(int)xp[j]];			
		    }
		}
		fclose(FH);
//		printf("%d lines found\n",np);
		command='X';
	    }

	    if (command=='F') {
		printf("Identification file to recenter?");
		scanf("%s",file);
		printf("Opening file: %s\n",file);
		np=0;
		if ((FH=fopen(file,"r"))==NULL) {
		    printf("Error opening file: %s\n",file);
		    return(-1);
		} else {    
		    while((car=getc(FH))!=EOF) {
			flag=1;
			if (car=='\n')
			{
			    np+=1;
			    flag+=1;
			}
		    }
		    if (flag==1) {
			np=np+1;
		    } else {
			np=np;
		    }
		    printf("NP=%d\n",np);
		    rewind(FH);
		    for (j=0;j<np;j++) {
			fscanf(FH, "%f", &xtt[j]);
		    }

		    for (j=0;j<np;j++) {
			x=xtt[j];
			i_min=(int)(x)-aperture;
			i_max=(int)(x)+aperture;
			i_peak=(int)(x);
			maximun=-1e12;
			for (i=i_min;i<i_max;i++) {
			    if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
				i_peak=i;
				maximun=spec[i];
			    }
			}
			a=i_peak-1;
			b=i_peak;
			c=i_peak+1;
			fa=-spec[a];
			fb=-spec[b];
			fc=-spec[c];
			den=(fc-2*fb+fa);
			if (den!=0) {
			    x_peak=c-(b-a)*((fc-fb)/den+0.5);
			} else {
			    x_peak=i_peak;
			}
			xp[j]=x_peak;
			yp[j]=spec[i_peak];
			mp[j]=1;
//			printf("VAL=%d %d %f %f %f\n",j,np,xtt[j],xp[j],yp[j]);

		    }
		    

		    for (i=0;i<np;i++) {
			for (j=(i+1);j<np;j++) {
			    if (xp[j]<xp[i]) {
				temp=xp[j];
				xp[j]=xp[i];
				xp[i]=temp;
			    }    
			}
		    }
		    for (j=0;j<np;j++) {
//			printf("%d %f\n",j,xp[j]);
			mp[j]=1;
			yp[j]=spec[(int)xp[j]];			
		    }
		}
		fclose(FH);
//		printf("%d lines found\n",np);
		command='X';

		cpgsch(2);
		cpgsci(5);
		for (i=0;i<np;i++) {
		    xs[0]=xp[i];
		    ys[0]=yp[i];
		    if (mp[i]==1) {
			cpgpt(1,xs,ys,2);
		    }
		}
		cpgsci(1);
		cpgsch(1.2);

	    }







	
	    if (command=='W') {
		printf("Saving Identification file?"); 
		scanf("%s",file);
		FH=fopen(file,"w");
		for (j=0;j<np;j++) {
		    if (mp[j]==1) {
			fprintf(FH,"%f\n",xp[j]);
		    }
		}
		fclose(FH);
		command='X';
	    }
	    
//	    printf("command=%c [%f,%f]\n",command,x,y);
	    
	    if (command=='m') {
		xs[0]=x;
		ys[0]=spec[(int)floor(x)];
		cpgsci(8);
		cpgpt(1,xs,ys,2);
		cpgsci(1);
		i_min=(int)floor(x)-aperture;
		i_max=(int)floor(x)+aperture;
		i_peak=(int)floor(x);
		maximun=-1e12;
//		printf("[%d,%d]\n",i_min,i_max);
		for (i=i_min;i<i_max;i++) {
		    if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
			i_peak=i;
			maximun=spec[i];
		    }
		}
//		printf("Has pulsado M a x=%f, %d,%f\n",x,i_peak,maximun);
//		fflush(stdout);

		a=i_peak-1;
		b=i_peak;
		c=i_peak+1;
		fa=-spec[a];
		fb=-spec[b];
		fc=-spec[c];
		den=(fc-2*fb+fa);
		if (den!=0) {
		    x_peak=c-(b-a)*((fc-fb)/den+0.5);
		} else {
		    x_peak=i_peak;
		}
		xp[np]=x_peak;
		yp[np]=spec[i_peak];
		mp[np]=1;
		np++;
		cpgsch(2);
		cpgsci(5);
		for (i=0;i<np;i++) {
		    xs[0]=xp[i];
		    ys[0]=yp[i];
		    if (mp[i]==1) {
			cpgpt(1,xs,ys,2);
		    }
		}
		cpgsci(1);
		cpgsch(1.2);
		command='X';
	    }
	    if (command=='d') {
		xs[0]=x;
		ys[0]=spec[(int)floor(x)];
		i_min=(int)floor(x)-aperture;
		i_max=(int)floor(x)+aperture;
		i_peak=(int)floor(x);
		printf("%d %d %d\n",i_min,i_max,i_peak);
		for (i=0;i<np;i++) {
		    if (fabs(i_peak-xp[i])<aperture) {
			mp[i]=0;
		    }
		}
		cpgsch(2);
		for (i=0;i<np;i++) {
		    xs[0]=xp[i];
		    ys[0]=yp[i];		    
		    if (mp[i]==1) {
			cpgsci(5);
			cpgpt(1,xs,ys,2);
		    } else {
			cpgsci(2);
			cpgpt(1,xs,ys,22);
		    }
		}
		cpgsci(1);
		cpgsch(1.2);
		command='X';
	    }
	    

	}
    }    while(QUIT!='Y');

    cpgclos();
    cpgend();

    command=' ';
// 
//  Cleaning the peaks
// 
    n_peak=0;
    for (i=0;i<np;i++) {
	if (mp[i]==1) {
	    n_peak++;
	}
    }
    peaks_cen = (float *)malloc((n_peak)*sizeof(float));  	
    peaks_now = (float *)malloc((n_peak)*sizeof(float));  	
    x_of_peaks = (float *)malloc((n_peak)*sizeof(float));  	
    dpeaks_now = (float *)malloc((n_peak)*sizeof(float));  
    a_peaks = (float *)malloc((n_peak*image.ny)*sizeof(float));  	       
    a_new_peaks = (float *)malloc((n_peak*image.ny)*sizeof(float));  

    j=0;
    for (i=0;i<np;i++) {
	if (mp[i]==1) {
	    peaks_cen[j]=xp[i];//+delta_xp[i];
	    peaks_now[j]=xp[i];
	    j++;
	}
    }
    printf("Final number of peaks=%d\n",n_peak);
// 
//  We determine the offset with respect to the reference spectrum:
// 

    ny_cen=(int)(image.ny/2);
    fmin=1e12;
    fmax=-1e12;
    for (j=0;j<image.ny;j++) {
	for (i=0;i<image.nx;i++) {
	    w[i]=i*1.0;
	    spec[i]=RD_frame(&image,i,j);
	    if (fmin>spec[i]) {
		fmin=spec[i];
	    }
	    if (fmax<spec[i]) {
		fmax=spec[i];
	    }
	}
	mean_flux=fmean(spec,image.nx);
	sigma_flux=fsigma(spec,image.nx,mean_flux);
// 
//  We look for the new peaks
// 
	for (k=0;k<n_peak;k++) {
//	    if (j==0) {
		xs[0]=peaks_cen[k];
//	    } else {
//		xs[0]=a_peaks[j-1+k*image.ny];
//	    }
	    i_min=(int)floor(xs[0])-aperture;
	    i_max=(int)floor(xs[0])+aperture;
	    i_peak=(int)floor(xs[0]);
	    maximun=-1e12;
	    peak_found=0;
	    dpeak_last=10000;
	    for (i=i_min;i<i_max;i++) {
//		if (j==0) {
		    dpeak=fabs(1.0*i-peaks_cen[k]);
//		} else {
//		    dpeak=fabs(1.0*i-a_peaks[j-1+k*image.ny]);
//		}
//		if ((spec[i]>spec[i-1])&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])&&(spec[i]>maximun)&&(dpeak<dpeak_last)) {
//		if ((spec[i]>spec[i-1])&&(spec[i]>spec[i+1])&&(dpeak<dpeak_last)) {
		if ((spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])&&(spec[i]>maximun)) {
//		if ((spec[i]>spec[i-1])&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])&&(spec[i]>maximun)) {
		    i_peak=i;
		    maximun=spec[i];
		    peak_found=1;
		    dpeak_last=dpeak;
		}
	    }
//	    printf("%d %d %d %d %f\n",i_min,i_max,i_peak,peak_found,xs[0]);
	    a=i_peak-1;
	    b=i_peak;
	    c=i_peak+1;
	    fa=-spec[a];
	    fb=-spec[b];
	    fc=-spec[c];
	    den=(fc-2*fb+fa);
	    if (den!=0) {
		x_peak=c-(b-a)*((fc-fb)/den+0.5);	    
	    } else {
		x_peak=1.0*i_peak;
	    }
	    if (peak_found==0) {		
		x_peak=xs[0];
	    }
	    peaks_now[k]=x_peak;
	    dpeaks_now[k]=peaks_cen[k]-x_peak;
//	    if ((x_peak>(peaks_cen[k]-2*aperture))&&(x_peak<(peaks_cen[k]+2*aperture))) {
		a_peaks[j+k*image.ny]=x_peak;
//	    } else {
//		a_peaks[j+k*image.ny]=peaks_cen[k];
//	    }
	}
//	printf("PASO\n");
//	fflush(stdout);



	if ((plot==1)||(plot==2)) {
	    cpgopen("/xs");
	    cpgsfs(1.2);
	    cpgscf(2);             //  Set character font
	    cpgslw(2);             //  Set line width
	    cpgsch(1.2);           //  Set character height
	    cpgenv(borders[0],borders[1],borders[2],borders[3],0,1);
	    cpglab("X","counts","");
	    cpgsci(1);
	    cpgsci(7);
	    cpgline(image.nx,w,spec);
	    cpgsch(2);
	    for (i=0;i<n_peak;i++) {
		xs[0]=peaks_cen[i];// +shift_all[j];
		ys[0]=spec[(int)(peaks_cen[i])];
		cpgsci(4);
		cpgpt(1,xs,ys,2);
		xs[0]=peaks_now[i];
		ys[0]=spec[(int)(peaks_now[i])];
		cpgsci(3);
		cpgslw(3);
		xx[0]=xs[0];
		xx[1]=xs[0];
		yy[0]=1.2*ys[0];
		yy[1]=1.6*ys[0];
		cpgline(2,xx,yy);
		cpgslw(4);
	    }
	    cpgsch(1.2);
	    cpgsci(1);
	    cpgclos();
	    cpgend();
	    
	    if ((command!='A')||(command!='0')) {
		printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
		command=getc(stdin);
	    }
	    if (command=='0') {
		plot=0;
	    }
	    if (command=='Q') {
		plot=0;
	    }
	    if (command=='N') {
		plot=3;
	    }
	} else {
	    if (j==100*floor(j/100)) {
		printf("%d/%d\n",j,image.ny);
	    }
	}
    }

// 
//  Smoothing process
// 
// 
    if (nbox>3) {
	xt = (float *)malloc((image.ny)*sizeof(float));  	
	for (k=0;k<n_peak;k++) {	
	    for (j=0;j<image.ny;j++) {
		kk=0;
		if (j<nbox) {
		    j_min=j;
		    j_max=j+2*nbox;
		} else {
		    if (j>=(image.ny-nbox)) {
			j_min=j-2*nbox;
			j_max=j;
		    } else {
			j_min=j-nbox;
			j_max=j+nbox;
		    }
		}
		tmp = (float *)malloc((j_max-j_min+1)*sizeof(float));  	
		for (i=j_min;i<j_max;i++) {
		    tmp[kk]=a_peaks[i+k*image.ny];
		    kk++;
		}
		me=fmedian(tmp,kk);
		sig=fsigma(tmp,kk,me);
		free(tmp);
		if (fabs(xt[j]-me)<nsigma2*sig) {
		    xt[j]=a_peaks[j+k*image.ny];
		} else {
		    xt[j]=me;
		}
	    }
	    for (j=0;j<image.ny;j++) {	
		a_new_peaks[j+k*image.ny]=xt[j];		
	    }
	}
	free(xt);
    } else {
	for (k=0;k<n_peak;k++) {	
	    for (j=0;j<image.ny;j++) {
		a_new_peaks[j+k*image.ny]=a_peaks[j+k*image.ny];
	    }
	}
    }
    if (command=='N') {
	plot=3;
    }

    command=' ';
    fflush(stdin);
    if ((plot==1)||(plot==2)||(plot==3)) {

	cpgopen("/xs");
	cpgask(0);
	cpgsfs(1.2);
	cpgscf(2);             //  Set character font
	cpgslw(2);             //  Set line width
	cpgsch(1.2);           //  Set character height
	xP = (float *)malloc((image.ny)*sizeof(float));  	
	yP = (float *)malloc((image.ny)*sizeof(float));  	
	sxP = (float *)malloc((image.ny)*sizeof(float));  	
	for (k=0;k<n_peak;k++) {	
	    for (j=0;j<image.ny;j++) {	
		xP[j]=a_peaks[j+k*image.ny];
		sxP[j]=a_new_peaks[j+k*image.ny];
//		sxP[j]=a_peaks[j+k*image.ny];
		yP[j]=1.0*j;
//		printf("%d %f %f\n",j,xP[j],sxP[j]);
	    }
	    me=fmean(xP,image.ny);
	    sig=fsigma(xP,image.ny,me);
	    cpgenv(me-2*sig,me+2*sig,0,image.ny,0,0);
	    cpglab("Y-Axis","X-axis","Distortion");
	    cpgsci(1);
	    cpgpt(image.ny,xP,yP,2);
	    cpgsci(3);
	    cpgline(image.ny,sxP,yP);
	    //cpgline(image.ny,xP,yP);
	    cpgsci(1);
	    if ((command!='A')||(command!='0')) {
		printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
		command=getc(stdin);
	    }
	    if (command=='0') {
		plot=0;
	    }
	    if (command=='Q') {
		plot=0;
	    }
	    if (command=='N') {
		plot=4;
	    }

	}
	free(xP);
	free(sxP);
	free(yP);
	cpgclos();
	cpgend();
    }
    
    a_dist = (float *)malloc((image.nx*image.ny)*sizeof(float));  	
    a_i_new = (float *)malloc((image.nx)*sizeof(float));  	
    da_i_new = (float *)malloc((image.nx)*sizeof(float));  	
    a_i_old = (float *)malloc((image.nx)*sizeof(float));  	
    dnx_max=-1e12;
    dnx_min=1e12;
    printf("Fitting the distortion\n");
        for (j=0;j<image.ny;j++) {
	    for (k=0;k<n_peak;k++) {
		peaks_now[k]=a_new_peaks[j+k*image.ny];	
		dpeaks_now[k]=peaks_cen[k]-a_new_peaks[j+k*image.ny];
		if ((dnx_max<dpeaks_now[k])&&(dpeaks_now[k]<4)) {
		    dnx_max=dpeaks_now[k]+0.5;// *dpeaks_now[k];
		}
		if ((dnx_min>dpeaks_now[k])&&(dpeaks_now[k]>-4)) {
		    dnx_min=dpeaks_now[k]-0.5;// *dpeaks_now[k];
		}
	    }
//	    dnx_max=-1;
//	    dnx_min=1;

	    if (npoly==0) {
		for (i=0;i<image.nx;i++) {
		    a_i_old[i]=i;
		}
		spline1_old(peaks_cen,peaks_now,n_peak,a_i_old,a_i_new,image.nx);
		for (i=0;i<image.nx;i++) {
		    a_dist[i+j*image.nx]=a_i_new[i];
		    da_i_new[i]=-a_i_new[i]+a_i_old[i];
		}
	    } else {
		if (npoly>0) {
		    coeff = (float *)malloc((npoly)*sizeof(float));  	
		    polyfit(peaks_cen,peaks_now,n_peak,coeff,npoly);
		    for (i=0;i<image.nx;i++) {
			a_dist[i+j*image.nx]=0;
			for (kk=0;kk<npoly;kk++) {
			//printf("%d %f\n",kk,coeff[kk]);
			    a_dist[i+j*image.nx]=a_dist[i+j*image.nx]+coeff[kk]*pow(i,kk);
			}	    
			a_i_new[i]=a_dist[i+j*image.nx];
			a_i_old[i]=i;
			da_i_new[i]=-a_i_new[i]+a_i_old[i];
		    }	
		    free(coeff);
		} else {
		    coeff = (float *)malloc((abs(npoly))*sizeof(float));  	
//		    legendrefit(peaks_cen,peaks_now,n_peak,coeff,abs(npoly));
		    chebyshevfit(peaks_cen,peaks_now,n_peak,coeff,abs(npoly));


		    for (i=0;i<image.nx;i++) {
			a_dist[i+j*image.nx]=0;
			for (kk=0;kk<abs(npoly);kk++) {
	    		     
//			    a_dist[i+j*image.nx]=a_dist[i+j*image.nx]+coeff[kk]*legendre(i,kk);
			    a_dist[i+j*image.nx]=a_dist[i+j*image.nx]+coeff[kk]*chebyshev(i,kk);
//			    printf("kk=%d %d %f\n",kk,abs(npoly),a_dist[i+j*image.nx]);

			}	    
			a_i_new[i]=a_dist[i+j*image.nx];
			a_i_old[i]=i;
			da_i_new[i]=-a_i_new[i]+a_i_old[i];
		    }	

		    free(coeff);
		}
	    }
	    if ((plot==1)||(plot==2)||(plot==3)||(plot==4)) {
		cpgopen("/xs");
		cpgsfs(1.2);
		cpgscf(2);             //  Set character font
		cpgslw(2);             //  Set line width
		cpgsch(1.2);           //  Set character height
		cpgenv(0,image.nx,dnx_min,dnx_max,0,0);
		cpglab("X old","\\gD X new","");
		cpgsci(1);
		cpgpt(n_peak,peaks_now,dpeaks_now,2);
		cpgsci(2);
		cpgline(image.nx,a_i_old,da_i_new);
		cpgclos();
		cpgend();
		if ((command!='A')||(command!='0')) {
		    printf("Press Enter (A for automatic, 0 for no plot, N for next plot):\n"); 
		    command=getc(stdin);
		}
		if (command=='0') {
		    plot=0;
		}
		if (command=='Q') {
		    plot=0;
		}
		if (command=='N') {
		    plot=5;
		}
	    }  else {
		if (j==100*floor(j/100)) {
		    printf("%d/%d\n",j,image.ny);
		}
	    }
	}
   

    printf("DONE\n");



    printf("Writting the distortion solution: %s\n",disp_file);
    create_frame(&dist,disp_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    for (i=0;i<npix[0];i++) {
	for (j=0;j<npix[1];j++) {
	    WR_frame(&dist,i,j,a_dist[i+j*npix[0]]);
	}
    }
    close_frame(&dist);    

    out_array = (float *)malloc((image.nx*image.ny)*sizeof(float)); 


   printf("Correcting the distortion...\n");
    for (j=0;j<npix[1];j++) {
	fmin=1e12;
	fmax=-1e12;
	for (i=0;i<npix[0];i++) {
	    a_i_old[i]=a_dist[i+j*npix[0]];
	    spec[i]=RD_frame(&image,i,j);
	    w[i]=1.0*i;
	}

	spline1(w,spec,npix[0],a_i_old,out_spec,npix[0]);
	
	for (i=0;i<npix[0];i++) {
	    w_new[i]=1.0*i;
	    out_array[i+j*npix[0]]=out_spec[i];
	}
    }
    close_frame(&image);     

    printf("Writting the corrected data: %s\n",out_file);
    create_frame(&dist_cor,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    for (i=0;i<npix[0];i++) {
	for (j=0;j<npix[1];j++) {
	    WR_frame(&dist_cor,i,j,out_array[i+j*npix[0]]);
	}
    }
    close_frame(&dist_cor);    

    return(0);
}
